
#define CONFIG_PATH			"configs/personal_skins.txt"
#define DOWNLOADLIST_PATH	"configs/personalskins_downloadslist.txt"
#define COMMAND_RELOAD		"sm_pskins_reload"




#pragma semicolon 1

#include <sourcemod>
#include <sdktools>

#undef REQUIRE_PLUGIN
#tryinclude <zombiereloaded>

#define PLUGIN_VERSION		"1.6"


#define CS_TEAM_T 2
#define CS_TEAM_CT 3


#define IP		0
#define STEAM	1
#define FLAGS	2
#define GROUPS	3
#define NAMES	4
#define ALL		5

new bool:b_enabled;


#define SKIN_T 0
#define SKIN_CT 1

#if defined _zr_included
	new bool:zombiereloaded = false;
	new String:MODEL_ZOMBIE_KEY[32] = "ModelZombie";
	new String:MODEL_HUMAN_KEY[32] = "ModelHuman";
	
	#define SKIN_ZOMBIE 2
	#define SKIN_MAX 3
#else
	#define SKIN_MAX 2
#endif

new String:s_FileSettingsPath[PLATFORM_MAX_PATH];
new Handle:hArraySkins[MAXPLAYERS+1][SKIN_MAX];

new Float:MODEL_SET_DELAY = 0.15;
new String:MODEL_T_KEY[32] = "ModelT";
new String:MODEL_CT_KEY[32] = "ModelCT";
new String:MODEL_PASSWORD_KEY[32] = "password";
new String:CLIENT_PASSWORD_KEY[32] = "_skins_password";

new Handle:kv,
	Handle:h_Enable;

new bool:b_late;

public Plugin:myinfo = 
{
	name = "Personal Player Skins",
	author = "FrozDark (HLModders LLC)",
	description = "Personal Player Skins",
	version = PLUGIN_VERSION,
	url = "www.hlmod.ru"
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	#if defined _zr_included
	MarkNativeAsOptional("ZR_IsClientHuman");
	MarkNativeAsOptional("ZR_IsClientZombie");
	#endif
	
	b_late = late;

	return APLRes_Success;
}

public OnPluginStart()
{
	CreateConVar("sm_personalskins_version", PLUGIN_VERSION, "The plugin's version", FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY|FCVAR_CHEAT|FCVAR_DONTRECORD);
	
	h_Enable = CreateConVar("sm_personalskins_enable", "1", "Enables/Disables the plugin", 0, true, 0.0, true, 1.0);
	b_enabled = GetConVarBool(h_Enable);
	HookConVarChange(h_Enable, CvarChanges);
	
	BuildPath(Path_SM, s_FileSettingsPath, sizeof(s_FileSettingsPath), CONFIG_PATH);
	RegAdminCmd(COMMAND_RELOAD, Command_Reload, ADMFLAG_ROOT);
	
	HookEvent("player_spawn", Event_PlayerSpawn);
	HookEvent("player_team", Event_PlayerSpawn);
}

#if defined _zr_included
public OnAllPluginsLoaded()
{
	zombiereloaded = LibraryExists("zombiereloaded");
}

public OnLibraryAdded(const String:name[])
{
	if (StrEqual(name, "zombiereloaded"))
	{
		zombiereloaded = true;
	}
}

public OnLibraryRemoved(const String:name[])
{
	if (StrEqual(name, "zombiereloaded"))
	{
		zombiereloaded = false;
	}
}
#endif

public OnMapStart()
{
	ReadConfig();
	if (b_late)
	{
		for (new i = 1; i <= MaxClients; i++)
		{
			if (IsClientInGame(i) && IsClientAuthorized(i))
			{
				OnClientPostAdminCheck(i);
			}
		}
		b_late = false;
	}
}

public Action:Command_Reload(client, args)
{
	ReadConfig();
	
	for (new i = 1; i <= MaxClients; i++)
	{
		if (IsClientInGame(i) && IsClientAuthorized(i))
		{
			OnClientPostAdminCheck(i);
		}
	}
	
	ReplyToCommand(client, "Personal Player Skins settings has been successfuly loaded!");
	
	return Plugin_Handled;
}

ReadConfig()
{
	if (kv != INVALID_HANDLE)
	{
		CloseHandle(kv);
	}
	
	kv = CreateKeyValues("SkinSettings");
	
	if (!FileToKeyValues(kv, s_FileSettingsPath))
	{
		SetFailState("File '%s' not found!", s_FileSettingsPath);
	}
	
	MODEL_SET_DELAY = KvGetFloat(kv, "model_set_delay", 0.15);
	
	KvGetString(kv, "team_1_key", MODEL_T_KEY, sizeof(MODEL_T_KEY), "ModelT");
	KvGetString(kv, "team_2_key", MODEL_CT_KEY, sizeof(MODEL_CT_KEY), "ModelCT");
	KvGetString(kv, "password_key", MODEL_PASSWORD_KEY, sizeof(MODEL_PASSWORD_KEY), "password");
	KvGetString(kv, "client_pass_key", CLIENT_PASSWORD_KEY, sizeof(CLIENT_PASSWORD_KEY), "_skins_password");
	
	#if defined _zr_included
	KvGetString(kv, "zombie_key", MODEL_ZOMBIE_KEY, sizeof(MODEL_ZOMBIE_KEY), "ModelZombie");
	KvGetString(kv, "human_key", MODEL_HUMAN_KEY, sizeof(MODEL_HUMAN_KEY), "ModelHuman");
	#endif
	
	decl String:buffer[PLATFORM_MAX_PATH];
	BuildPath(Path_SM, buffer, sizeof(buffer), DOWNLOADLIST_PATH);
	if (!File_ReadDownloadList(buffer))
	{
		PrintToServer("File not exists %s", buffer);
	}
	
	KvRewind(kv);
	if (KvJumpToKey(kv, "Flags"))
	{
		ReadNode(true);
	}
	if (KvJumpToKey(kv, "Groups"))
	{
		ReadNode();
	}
	if (KvJumpToKey(kv, "Names"))
	{
		ReadNode();
	}
	
	ReadNode();
}

ReadNode(bool:flags = false)
{
	if (KvGotoFirstSubKey(kv))
	{
		decl String:buffer[PLATFORM_MAX_PATH];
		do
		{
			KvGetSectionName(kv, buffer, sizeof(buffer));
			
			if (flags)
			{
				KvSetNum(kv, "flags", ReadFlagString(buffer));
			}
			else if (StrEqual(buffer, "Flags", false) || StrEqual(buffer, "Groups", false) || StrEqual(buffer, "Names", false)) continue;
			
			KvSavePosition(kv);
			if (KvGotoFirstSubKey(kv, false))
			{
				do
				{
					KvGetSectionName(kv, buffer, sizeof(buffer));
					#if defined _zr_included
					if (StrEqual(buffer, MODEL_T_KEY) || StrEqual(buffer, MODEL_CT_KEY) || StrEqual(buffer, MODEL_ZOMBIE_KEY) || StrEqual(buffer, MODEL_HUMAN_KEY))
					#else
					if (StrEqual(buffer, MODEL_T_KEY) || StrEqual(buffer, MODEL_CT_KEY))
					#endif
					{
						KvGetString(kv, NULL_STRING, buffer, sizeof(buffer));
						
						if (buffer[0])
						{
							if (!IsModelFile(buffer))
							{
								LogError("Invalid extension in the model - %s. Skipping...", buffer);
								KvDeleteThis(kv);
							}
							else
							{
								PrecacheModel(buffer);
							}
						}
					}
				}
				while (KvGotoNextKey(kv, false));
				
				KvGoBack(kv);
			}
		}
		while (KvGotoNextKey(kv));
	}
	KvRewind(kv);
}

public CvarChanges(Handle:convar, const String:oldValue[], const String:newValue[])
{
	if (convar == h_Enable)
	{
		if (bool:StringToInt(newValue) != b_enabled)
		{
			b_enabled = !b_enabled;
			if (b_enabled)
			{
				HookEvent("player_spawn", Event_PlayerSpawn);
				HookEvent("player_team", Event_PlayerSpawn);
			}
			else
			{
				UnhookEvent("player_spawn", Event_PlayerSpawn);
				UnhookEvent("player_team", Event_PlayerSpawn);
			}
		}
	}
}

public Event_PlayerSpawn(Handle:event, const String:name[], bool:dontBroadcast)
{
	CreateTimer(MODEL_SET_DELAY, SetClientModel, GetEventInt(event, "userid"), TIMER_FLAG_NO_MAPCHANGE);
}

#if defined _zr_included
public ZR_OnClientInfected(client, attacker, bool:motherInfect, bool:respawnOverride, bool:respawn)
{
	CreateTimer(MODEL_SET_DELAY, SetClientModel, GetClientUserId(client), TIMER_FLAG_NO_MAPCHANGE);
}

public ZR_OnClientHumanPost(client, bool:respawn, bool:protect)
{
	CreateTimer(MODEL_SET_DELAY, SetClientModel, GetClientUserId(client), TIMER_FLAG_NO_MAPCHANGE);
}
#endif

public Action:SetClientModel(Handle:timer, any:userid)
{
	new client = GetClientOfUserId(userid);
	
	if (!client || !IsPlayerAlive(client))
	{
		return;
	}
	
	#if defined _zr_included
	if (zombiereloaded)
	{
		if (ZR_IsClientHuman(client))
		{
			new random1 = -1, random2 = -1;
			if (hArraySkins[client][SKIN_T] != INVALID_HANDLE)
			{
				random1 = Math_GetRandomInt(0, GetArraySize(hArraySkins[client][SKIN_T])-1);
			}
			if (hArraySkins[client][SKIN_CT] != INVALID_HANDLE)
			{
				random2 = Math_GetRandomInt(0, GetArraySize(hArraySkins[client][SKIN_CT])-1);
			}
			
			decl String:model[PLATFORM_MAX_PATH];
			if (Math_GetRandomInt(0, 1) == 0 && random1 != -1)
			{
				GetArrayString(hArraySkins[client][SKIN_T], random1, model, sizeof(model));
				SetEntityModel(client, model);
			}
			else if (random2 != -1)
			{
				GetArrayString(hArraySkins[client][SKIN_CT], random2, model, sizeof(model));
				SetEntityModel(client, model);
			}
		}
		else
		{
			if (hArraySkins[client][SKIN_ZOMBIE] != INVALID_HANDLE)
			{
				new random = Math_GetRandomInt(0, GetArraySize(hArraySkins[client][SKIN_ZOMBIE])-1);
				
				decl String:model[PLATFORM_MAX_PATH];
				GetArrayString(hArraySkins[client][SKIN_ZOMBIE], random, model, sizeof(model));
				SetEntityModel(client, model);
			}
		}
	}
	else
	{
	#endif
		switch (GetClientTeam(client))
		{
			case CS_TEAM_T :
			{
				if (hArraySkins[client][SKIN_T] != INVALID_HANDLE)
				{
					new random = Math_GetRandomInt(0, GetArraySize(hArraySkins[client][SKIN_T])-1);
					
					decl String:model[PLATFORM_MAX_PATH];
					GetArrayString(hArraySkins[client][SKIN_T], random, model, sizeof(model));
					SetEntityModel(client, model);
				}
			}
			case CS_TEAM_CT :
			{
				if (hArraySkins[client][SKIN_CT] != INVALID_HANDLE)
				{
					new random = Math_GetRandomInt(0, GetArraySize(hArraySkins[client][SKIN_CT])-1);
					
					decl String:model[PLATFORM_MAX_PATH];
					GetArrayString(hArraySkins[client][SKIN_CT], random, model, sizeof(model));
					SetEntityModel(client, model);
				}
			}
		}
	#if defined _zr_included
	}
	#endif
}

public OnClientPostAdminCheck(client)
{
	decl String:auth[22];
	if (!(GetClientAuthString(client, auth, sizeof(auth), false) && ApplyModel(client, auth, STEAM)) && !(GetClientIP(client, auth, sizeof(auth)) && ApplyModel(client, auth, IP)) && !ApplyModel(client, "Names", NAMES) && !ApplyModel(client, "Groups", GROUPS) && !ApplyModel(client, "Flags", FLAGS))
	{
		ApplyModel(client, "all", ALL);
	}
}

public OnClientDisconnect_Post(client)
{
	if (hArraySkins[client][SKIN_T] != INVALID_HANDLE)
	{
		CloseHandle(hArraySkins[client][SKIN_T]);
		hArraySkins[client][SKIN_T] = INVALID_HANDLE;
	}
	if (hArraySkins[client][SKIN_CT] != INVALID_HANDLE)
	{
		CloseHandle(hArraySkins[client][SKIN_CT]);
		hArraySkins[client][SKIN_CT] = INVALID_HANDLE;
	}
	#if defined _zr_included
	if (hArraySkins[client][SKIN_ZOMBIE] != INVALID_HANDLE)
	{
		CloseHandle(hArraySkins[client][SKIN_ZOMBIE]);
		hArraySkins[client][SKIN_ZOMBIE] = INVALID_HANDLE;
	}
	#endif
}

bool:ApplyModel(client, const String:key[], mode)
{
	if (IsFakeClient(client) && mode != STEAM && mode != ALL)
	{
		return false;
	}
	
	KvRewind(kv);
	if (KvJumpToKey(kv, key))
	{
		switch (mode)
		{
			case FLAGS : 
			{
				if (ReadFlagsModels(client))
				{
					return true;
				}
			}
			case GROUPS :
			{
				new AdminId:id = GetUserAdmin(client);
				if (id != INVALID_ADMIN_ID)
				{
					decl String:group[64];
					for (new i = 0; i < GetAdminGroupCount(id); i++)
					{
						if (GetAdminGroup(id, i, group, sizeof(group)) != INVALID_GROUP_ID && KvJumpToKey(kv, group) && ReadModels(client))
						{
							return true;
						}
					}
				}
			}
			case NAMES :
			{
				decl String:name[MAX_NAME_LENGTH+1];
				if (GetClientName(client, name, sizeof(name)) && KvJumpToKey(kv, name) && ReadModels(client))
				{
					return true;
				}
			}
			default :
			{
				if (ReadModels(client))
				{
					return true;
				}
			}
		}
	}
	return false;
}

bool:ReadModels(client)
{
	new bool:result = false;
	new bool:pass_found = false;
	new bool:pass_accessed = false;
	
	if (KvGotoFirstSubKey(kv, false))
	{
		decl String:buffer[PLATFORM_MAX_PATH];
		do
		{
			KvGetSectionName(kv, buffer, sizeof(buffer));
			#if defined _zr_included
			if (StrEqual(buffer, MODEL_T_KEY) || StrEqual(buffer, MODEL_HUMAN_KEY))
			#else
			if (StrEqual(buffer, MODEL_T_KEY))
			#endif
			{
				if (hArraySkins[client][SKIN_T] == INVALID_HANDLE)
				{
					hArraySkins[client][SKIN_T] = CreateArray(ByteCountToCells(PLATFORM_MAX_PATH));
				}
				KvGetString(kv, NULL_STRING, buffer, sizeof(buffer));
				if (!IsModelPrecached(buffer))
				{
					PrecacheModel(buffer);
				}
				PushArrayString(hArraySkins[client][SKIN_T], buffer);
				
				result = true;
			}
			else if (StrEqual(buffer, MODEL_CT_KEY))
			{
				if (hArraySkins[client][SKIN_CT] == INVALID_HANDLE)
				{
					hArraySkins[client][SKIN_CT] = CreateArray(ByteCountToCells(PLATFORM_MAX_PATH));
				}
				KvGetString(kv, NULL_STRING, buffer, sizeof(buffer));
				if (!IsModelPrecached(buffer))
				{
					PrecacheModel(buffer);
				}
				PushArrayString(hArraySkins[client][SKIN_CT], buffer);
				
				result = true;
			}
			#if defined _zr_included
			else if (StrEqual(buffer, MODEL_ZOMBIE_KEY))
			{
				if (hArraySkins[client][SKIN_ZOMBIE] == INVALID_HANDLE)
				{
					hArraySkins[client][SKIN_ZOMBIE] = CreateArray(ByteCountToCells(PLATFORM_MAX_PATH));
				}
				KvGetString(kv, NULL_STRING, buffer, sizeof(buffer));
				if (!IsModelPrecached(buffer))
				{
					PrecacheModel(buffer);
				}
				PushArrayString(hArraySkins[client][SKIN_ZOMBIE], buffer);
				
				result = true;
			}
			#endif
			else if (StrEqual(buffer, MODEL_PASSWORD_KEY))
			{
				KvGetString(kv, NULL_STRING, buffer, sizeof(buffer));
				if (buffer[0])
				{
					pass_found = true;
					decl String:pass[64];
					if (GetClientInfo(client, CLIENT_PASSWORD_KEY, pass, sizeof(pass)) && StrEqual(buffer, pass))
					{
						pass_accessed = true;
					}
				}
			}
		}
		while (KvGotoNextKey(kv, false));
	}
	
	KvRewind(kv);
	
	if (pass_found && !pass_accessed)
	{
		OnClientDisconnect_Post(client);
		return false;
	}
	
	return result;
}

bool:ReadFlagsModels(client)
{
	new bool:result = false;
	new flags = GetUserFlagBits(client);
	
	if (KvGotoFirstSubKey(kv))
	{
		do
		{
			if (bool:(flags & KvGetNum(kv, "flags")))
			{
				result = ReadModels(client);
				break;
			}
		}
		while (KvGotoNextKey(kv));
	}
	KvRewind(kv);
	
	return result;
}

bool:IsModelFile(const String:model[])
{
	decl String:buf[4];
	GetExtension(model, buf, sizeof(buf));
	
	return !strcmp(buf, "mdl", false);
}

stock GetExtension(const String:path[], String:buffer[], size)
{
	new extpos = FindCharInString(path, '.', true);
	
	if (extpos == -1)
	{
		buffer[0] = '\0';
		return;
	}

	strcopy(buffer, size, path[++extpos]);
}

stock ClearKV(Handle:kvhandle)
{
	KvRewind(kvhandle);
	while (KvGotoFirstSubKey(kvhandle))
	{
		KvDeleteThis(kvhandle);
		KvRewind(kvhandle);
	}
}



new String:_smlib_empty_twodimstring_array[][] = { { '\0' } };
stock File_AddToDownloadsTable(String:path[], bool:recursive=true, const String:ignoreExts[][]=_smlib_empty_twodimstring_array, size=0)
{
	if (path[0] == '\0') {
		return;
	}
	
	new len = strlen(path)-1;
	
	if (path[len] == '\\' || path[len] == '/')
	{
		path[len] = '\0';
	}

	if (FileExists(path)) {
		
		decl String:fileExtension[4];
		File_GetExtension(path, fileExtension, sizeof(fileExtension));
		
		if (StrEqual(fileExtension, "bz2", false) || StrEqual(fileExtension, "ztmp", false)) {
			return;
		}
		
		if (Array_FindString(ignoreExts, size, fileExtension) != -1) {
			return;
		}

		AddFileToDownloadsTable(path);
	}
	
	else if (recursive && DirExists(path)) {

		decl String:dirEntry[PLATFORM_MAX_PATH];
		new Handle:__dir = OpenDirectory(path);

		while (ReadDirEntry(__dir, dirEntry, sizeof(dirEntry))) {

			if (StrEqual(dirEntry, ".") || StrEqual(dirEntry, "..")) {
				continue;
			}
			
			Format(dirEntry, sizeof(dirEntry), "%s/%s", path, dirEntry);
			File_AddToDownloadsTable(dirEntry, recursive, ignoreExts, size);
		}
		
		CloseHandle(__dir);
	}
	else if (FindCharInString(path, '*', true)) {
		
		new String:fileExtension[4];
		File_GetExtension(path, fileExtension, sizeof(fileExtension));

		if (StrEqual(fileExtension, "*")) {

			decl
				String:dirName[PLATFORM_MAX_PATH],
				String:fileName[PLATFORM_MAX_PATH],
				String:dirEntry[PLATFORM_MAX_PATH];

			File_GetDirName(path, dirName, sizeof(dirName));
			File_GetFileName(path, fileName, sizeof(fileName));
			StrCat(fileName, sizeof(fileName), ".");

			new Handle:__dir = OpenDirectory(dirName);
			while (ReadDirEntry(__dir, dirEntry, sizeof(dirEntry))) {

				if (StrEqual(dirEntry, ".") || StrEqual(dirEntry, "..")) {
					continue;
				}

				if (strncmp(dirEntry, fileName, strlen(fileName)) == 0) {
					Format(dirEntry, sizeof(dirEntry), "%s/%s", dirName, dirEntry);
					File_AddToDownloadsTable(dirEntry, recursive, ignoreExts, size);
				}
			}

			CloseHandle(__dir);
		}
	}

	return;
}

stock bool:File_ReadDownloadList(const String:path[])
{
	new Handle:file = OpenFile(path, "r");
	
	if (file  == INVALID_HANDLE) {
		return false;
	}

	new String:buffer[PLATFORM_MAX_PATH];
	while (!IsEndOfFile(file)) {
		ReadFileLine(file, buffer, sizeof(buffer));
		
		new pos;
		pos = StrContains(buffer, "//");
		if (pos != -1) {
			buffer[pos] = '\0';
		}
		
		pos = StrContains(buffer, "#");
		if (pos != -1) {
			buffer[pos] = '\0';
		}

		pos = StrContains(buffer, ";");
		if (pos != -1) {
			buffer[pos] = '\0';
		}
		
		TrimString(buffer);
		
		if (buffer[0] == '\0') {
			continue;
		}

		File_AddToDownloadsTable(buffer);
	}

	CloseHandle(file);
	
	return true;
}

stock File_GetExtension(const String:path[], String:buffer[], size)
{
	new extpos = FindCharInString(path, '.', true);
	
	if (extpos == -1)
	{
		buffer[0] = '\0';
		return;
	}

	strcopy(buffer, size, path[++extpos]);
}

stock Math_GetRandomInt(min, max)
{
	new random = GetURandomInt();
	
	if (random == 0)
		random++;

	return RoundToCeil(float(random) / (float(2147483647) / float(max - min + 1))) + min - 1;
}

stock Array_FindString(const String:array[][], size, const String:str[], bool:caseSensitive=true, start=0)
{
	if (start < 0) {
		start = 0;
	}

	for (new i=start; i < size; i++) {

		if (StrEqual(array[i], str, caseSensitive)) {
			return i;
		}
	}
	
	return -1;
}

stock bool:File_GetFileName(const String:path[], String:buffer[], size)
{	
	if (path[0] == '\0') {
		buffer[0] = '\0';
		return;
	}
	
	File_GetBaseName(path, buffer, size);
	
	new pos_ext = FindCharInString(buffer, '.', true);

	if (pos_ext != -1) {
		buffer[pos_ext] = '\0';
	}
}

stock bool:File_GetDirName(const String:path[], String:buffer[], size)
{	
	if (path[0] == '\0') {
		buffer[0] = '\0';
		return;
	}
	
	new pos_start = FindCharInString(path, '/', true);
	
	if (pos_start == -1) {
		pos_start = FindCharInString(path, '\\', true);
		
		if (pos_start == -1) {
			buffer[0] = '\0';
			return;
		}
	}
	
	strcopy(buffer, size, path);
	buffer[pos_start] = '\0';
}

stock bool:File_GetBaseName(const String:path[], String:buffer[], size)
{	
	if (path[0] == '\0') {
		buffer[0] = '\0';
		return;
	}
	
	new pos_start = FindCharInString(path, '/', true);
	
	if (pos_start == -1) {
		pos_start = FindCharInString(path, '\\', true);
	}
	
	pos_start++;
	
	strcopy(buffer, size, path[pos_start]);
}